'Doctor Electron -- net census, http://www.angelfire.com/space/netcensus/

$APPTYPE GUI
$TYPECHECK ON

$RESOURCE XPress_ICO as "X-Press.ico"
CONST False = 0
CONST True = NOT False

Application.IcoHandle=Xpress_ICO
Application.Title="X-Press"

DECLARE SUB SendButtonClick
DECLARE SUB SendText(Key As BYTE)
DECLARE SUB ButtonClick
DECLARE SUB Dummy
DECLARE SUB ShowHelp
DECLARE SUB FormResize
Declare Function WSAGetLastError Lib "wsock32.dll" Alias "WSAGetLastError" () As LONG

DIM Peer AS QSocket
DIM Font As QFONT
DIM S As LONG, i As LONG
DIM t$ As STRING, e$ As STRING
DIM crlf As STRING
crlf=CHR$(13)+CHR$(10)
Font.Size = 10

CREATE ChatC AS QForm
  IcoHandle=XPress_ico
  Height = 272
  Width = 500
  Caption = "X-Press Chat Client"
  ShowHint = True
  OnShow = ShowHelp
  WndProc = Dummy
  CREATE Label1 AS QLabel
    Top = 7
    Left = 3
    Caption = "Server:"
  END CREATE
  CREATE Host AS QEdit
    Left = 40
    Top = 3
    Width = 150
    Height = 20
    Font = Font
    Hint = "Server name or IP address"
    Text = "127.0.0.1"
  END CREATE
  CREATE Label2 AS QLabel
    Top = 7
    Left = 195
    Caption = "Port:"
  END CREATE
  CREATE ChatPort AS QEdit
    Left = 220
    Top = 3
    Width = 50
    Height = 20
    Font = Font
    Hint = "Server port"
    Text = "6667"
  END CREATE
  CREATE Label3 AS QLabel
    Top = 7
    Left = 275
    Caption = "Alias"
  END CREATE
  CREATE Nick AS QEdit
    Left = 300
    Top = 3
    Width = 60
    Height = 20
    Font = Font
    Hint = "Put your nickname here"
    Text = "Nick"
  END CREATE
  CREATE Encrypt AS QCheckBox
    Left = 365
    Top = 5
    Width = 60
    Height = 20
    Checked = True
    Enabled = True
    Hint = "Checked = encryption ON"
    Caption = "Encrypt"
  END CREATE
  CREATE Button AS QButton
    Left = ChatC.ClientWidth-66
    Top = 5
    Height = 20
    Width = 66
    Hint = "Connects to chat server"
    Caption = "Connect"
    OnClick = ButtonClick
  END CREATE
  CREATE Dat AS QListBox
    Top = 28
    Left = 0
    Width = ChatC.ClientWidth
    Height = ChatC.ClientHeight-57
    Font = Font
    AddItems "Encrypt checked = All chat is encrypted over network and internet."
    AddItems "Only X-Press users can see encrypted chat text from other X-Press users."
    AddItems "Proprietary encryption by Doctor Electron.  Version: 12/27/02"
    AddItems "Copyright 2002 Global Services.  All Rights Reserved."
    AddItems "Encryption is not enabled in this version.  Please contact author."
    AddItems " "
    AddItems "Put server name or IP address in Server box & connect."
    AddItems " "
    Hint = "Saved to ChatLast.txt on disconnect"
  END CREATE
  CREATE Label4 AS QLabel
    Top = 33+Dat.Height
    Left = 3
    Caption = "Text:"
  END CREATE
  CREATE Wizdom AS QEdit
    Left = 30
    Top = 30+Dat.Height
    Font = Font
    Width = ChatC.ClientWidth-102
    Height = 20
    Hint = "Enter chat text & press Enter"
    OnKeyPress = SendText
  END CREATE
  CREATE SendButton AS QButton
    Left = ChatC.ClientWidth-66
    Top = 30+Dat.Height
    Height = 20
    Width = 66
    Caption = "Send"
    OnClick = SendButtonClick
  END CREATE
  ShowModal
END CREATE

SUB Dummy: End Sub

SUB ShowHelp
ChatC.OnResize=FormResize
Encrypt.Enabled=False
Encrypt.Checked=False
DoEvents
END SUB

SUB FormResize
Dat.Width = ChatC.ClientWidth
Dat.Height = ChatC.ClientHeight-57
Label4.Top = 33+Dat.Height
Wizdom.Top = 30+Dat.Height
Wizdom.Width = ChatC.ClientWidth-102
SendButton.Top = 30+Dat.Height
SendButton.Left = ChatC.ClientWidth-66
Button.Left = ChatC.ClientWidth-66
DoEvents
END SUB

SUB ButtonClick
IF Button.Caption="Disconnect" THEN Button.Caption ="Wait": Exit Sub
IF Button.Caption <> "Connect" THEN Exit Sub
Button.Caption="Connecting": Encrypt.Enabled=False
S=Peer.Connect(Host.Text, VAL(ChatPort.Text))
IF S > 0 THEN  
  Button.Caption="Disconnect"
ELSE
  ShowMessage "Unable to connect to: "+Host.Text+" on port "+ChatPort.Text
  Button.Caption="Connect": Exit Sub
END IF

Connected:
Sleep 0.1
IF Peer.IsServerReady(S)<=0 THEN Goto WaitCaption
e$=Peer.Read(S,512)
IF WSAGetLastError>0 THEN ShowMessage "Socket Read Error":Goto ExitChat
IF LEN(e$)<2 THEN e$="  "+e$
t$=LEFT$(e$,LEN(e$)-2)
IF t$="" THEN Goto CheckDisconnect
i=INSTR(1,t$,crlf)
IF i>0 THEN
  Dat.AddItems LEFT$(t$,i-1): DoEvents
  Dat.AddItems MID$(t$,i+2)
ELSE
  Dat.AddItems t$: DoEvents
END IF
IF Dat.ItemCount > 0 THEN Dat.ItemIndex = Dat.ItemCount - 1
CheckDisconnect:
IF Peer.Transferred<0 THEN
  ShowMessage "Server disconnected!"
  Goto ExitChat
END IF

WaitCaption:
DoEvents
IF Button.Caption = "Disconnect" THEN Goto Connected
IF S>0 THEN Peer.Write(S,"exit",4)
ExitChat:
Button.Caption="Connect"
IF S>0 THEN Peer.Close(S): S=0
Dat.SavetoFile("ChatLast.txt")
END SUB

SUB SendText(Key as BYTE)
IF Key=13 THEN Call SendButtonClick
END SUB

SUB SendButtonClick
IF S <= 0 THEN ShowMessage "You must be connected to a server first!": Exit Sub
t$=Nick.Text+"> "+Wizdom.Text
e$=t$
Peer.Write(S, e$, LEN(e$))
IF (WSAGetLastError > 0) OR (Wizdom.Text="exit") THEN
  Button.Caption = "Wait": ShowMessage "Disconnecting from Server."
END IF
Wizdom.Text=""  
END SUB
